//
//  UIWebViewLeaks2AppDelegate.m
//  UIWebViewLeaks2
//
//  Created by UIWebViewLeaks2 on 04/10/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "UIWebViewLeaks2AppDelegate.h"
#import "UIWebViewLeaks2ViewController.h"

@implementation UIWebViewLeaks2AppDelegate

@synthesize window;
@synthesize viewController;


#pragma mark -
#pragma mark Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    

    //[[NSUserDefaults standardUserDefaults] setInteger:0 forKey:@"WebKitCacheModelPreferenceKey"];
        
    NSLog(@"WebKitCacheModelPreferenceKey = %d (0=no cache, no leaks, 1=cache and huge leaks)",[[NSUserDefaults standardUserDefaults] integerForKey:@"WebKitCacheModelPreferenceKey"]);
  
    // Disable cache which causes these huge leaks
    [[NSUserDefaults standardUserDefaults] setInteger:0 forKey:@"WebKitCacheModelPreferenceKey"];
    //[[NSUserDefaults standardUserDefaults] removeObjectForKey:@"WebKitCacheModelPreferenceKey"];
  
    // Enable it and leaks!!
    //[[NSUserDefaults standardUserDefaults] setInteger:1 forKey:@"WebKitCacheModelPreferenceKey"];
  
    
    window = [[UIWindow alloc] init];
    viewController = [[UIWebViewLeaks2ViewController alloc] init];
    [viewController loadView];
  
    [window setFrame:[UIScreen mainScreen].applicationFrame];
    
    // Add the view controller's view to the window and display.
    [window addSubview:viewController.view];
    [window makeKeyAndVisible];

    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
}


@end
